﻿
Imports Inventor
Imports System.Drawing
Imports System.Windows.Forms
Imports Microsoft.VisualBasic.Compatibility.VB6
Imports stdole
Imports System.IO

Public Class ConvertThumb

  Public Sub ConvertThumbToByteArray(ByRef InvApp As Inventor.Application)
    Dim sFullFileName As String = CheckFileName(Clipboard.GetText)
    Clipboard.Clear()
    If sFullFileName = "" Then
      Exit Sub
    End If

    Dim oDoc As Inventor.Document = Nothing
    Dim img As Image = Nothing
    Dim imgMemoryStream As MemoryStream = New MemoryStream()
    Dim bBuffer As Byte() = Nothing
    Try
      oDoc = InvApp.Documents.ItemByName(sFullFileName)
    Catch e As Exception
      Exit Sub
    End Try

    Try
      img = IPictureDispToImage(oDoc.Thumbnail)
    Catch e As Exception
      Exit Sub
    End Try

    If img Is Nothing Then
      Exit Sub
    Else
      Dim imgOut As Image = CType(img.GetThumbnailImage(128, 128, Nothing, New IntPtr), Bitmap)
      imgOut.Save(imgMemoryStream, System.Drawing.Imaging.ImageFormat.Bmp)
      Clipboard.SetText(BitConverter.ToString(imgMemoryStream.GetBuffer()).Replace("-", ""))
    End If
  End Sub

  Private Function CheckFileName(ByVal sClip As String) As String
    Const SFLAG As String = ",THUMB_FROM_64BIT_PROCESS"
    If sClip.EndsWith(SFLAG) Then
      sClip = sClip.Substring(0, sClip.IndexOf(SFLAG))
    Else
      sClip = ""
    End If
    Return sClip
  End Function

End Class