Imports Inventor
Imports System.Runtime.InteropServices
Imports Microsoft.Win32

Namespace ThumbNailFix64Bit
  <ProgIdAttribute("ThumbNailFix64Bit.StandardAddInServer"), _
  GuidAttribute("74789d68-f4c9-4a17-a8d0-6468f7324988")> _
  Public Class StandardAddInServer
    Implements Inventor.ApplicationAddInServer

    ' Inventor application object.
    Private m_inventorApplication As Inventor.Application
    Private WithEvents m_AppOps As Inventor.ApplicationEvents
    Private m_Ops As DisplayOptions

#Region "ApplicationAddInServer Members"

    Public Sub Activate(ByVal addInSiteObject As Inventor.ApplicationAddInSite, ByVal firstTime As Boolean) Implements Inventor.ApplicationAddInServer.Activate

      ' This method is called by Inventor when it loads the AddIn.
      ' The AddInSiteObject provides access to the Inventor Application object.
      ' The FirstTime flag indicates if the AddIn is loaded for the first time.

      ' Initialize AddIn members.
      m_inventorApplication = addInSiteObject.Application

      ' TODO:  Add ApplicationAddInServer.Activate implementation.
      ' e.g. event initialization, command creation etc.
      m_Ops = m_inventorApplication.DisplayOptions
      m_AppOps = m_inventorApplication.ApplicationEvents

    End Sub

    Public Sub Deactivate() Implements Inventor.ApplicationAddInServer.Deactivate

      ' This method is called by Inventor when the AddIn is unloaded.
      ' The AddIn will be unloaded either manually by the user or
      ' when the Inventor session is terminated.

      ' TODO:  Add ApplicationAddInServer.Deactivate implementation

      ' Release objects.
      Marshal.ReleaseComObject(m_inventorApplication)
      m_inventorApplication = Nothing

      System.GC.WaitForPendingFinalizers()
      System.GC.Collect()

    End Sub

    Public ReadOnly Property Automation() As Object Implements Inventor.ApplicationAddInServer.Automation

      ' This property is provided to allow the AddIn to expose an API 
      ' of its own to other programs. Typically, this  would be done by
      ' implementing the AddIn's API interface in a class and returning 
      ' that class object through this property.

      Get
        Return Nothing
      End Get

    End Property

    Public Sub ExecuteCommand(ByVal commandID As Integer) Implements Inventor.ApplicationAddInServer.ExecuteCommand

      ' Note:this method is now obsolete, you should use the 
      ' ControlDefinition functionality for implementing commands.

    End Sub

#End Region

#Region "Inventor Events"

    Private Sub m_AppOps_OnApplicationOptionChange(BeforeOrAfter As Inventor.EventTimingEnum, Context As Inventor.NameValueMap, ByRef HandlingCode As Inventor.HandlingCodeEnum) Handles m_AppOps.OnApplicationOptionChange
      If BeforeOrAfter = EventTimingEnum.kBefore Then
        If m_Ops.Show3DIndicator = False Then
          Dim oConvert = New ConvertThumb
          oConvert.ConvertThumbToByteArray(m_inventorApplication)
        End If
      End If
    End Sub


#End Region
  End Class

End Namespace

